import { type IType, PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class Meetinglog {
  [PrimaryKeyProp]?: 'Id';
  Id!: IType<number, bigint>;
  MeetingId!: IType<number, bigint>;
  Speaker?: string;
  Content?: string;
  Revision!: number;
  CreatedBy?: IType<number, bigint>;
  CreatedTime!: Date;
  UpdatedBy?: IType<number, bigint>;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const MeetinglogSchema = defineEntity({
  class: Meetinglog,
  comment: '会议记录',
  properties: {
    Id: p.bigint().primary().name('Id').columnType('bigint').unsigned(false).autoincrement(false).comment('主键Id'),
    MeetingId: p.bigint().name('MeetingId').columnType('bigint').comment('会议Id'),
    Speaker: p.string().name('Speaker').nullable().comment('说话人名称'),
    Content: p.string().name('Content').length(1000).nullable().comment('内容'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').columnType('bigint').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').columnType('bigint').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
